#!/bin/bash

test_home=`dirname $0`
sanitydir=/usr/share/pacemaker/tests

if [ $test_home != $sanitydir ]; then
    # Running against the source tree
    GCOV_BASE=/home/iurt/rpmbuild/BUILD/ClusterLabs-pacemaker-394e906
    sanitydir=/home/iurt/rpmbuild/BUILD/ClusterLabs-pacemaker-394e906
    cd /home/iurt/rpmbuild/BUILD/ClusterLabs-pacemaker-394e906
    
    grep with-gcov config.log
    if [ $? = 0 ]; then
	echo "Pacemaker was built with gcov support"
    else
	echo "Re-building with gcov support"
	last=`grep --color=never "$.*configure" config.log | tail -n 1 | sed s:.*configure:./configure: | sed s:--no-create:--with-gcov:`
	eval $last
    fi
    
    #sudo make core core-install

else
    GCOV_BASE=/var/lib/pacemaker/gcov/
    mkdir -p $GCOV_BASE

    export GCOV_PREFIX_STRIP=4
    export GCOV_PREFIX=$GCOV_BASE

    cd `rpm -ql pacemaker-debuginfo | grep include | head -n 1`/..
    echo "Creating the directory structure in $GCOV_BASE from $PWD"
    # The .gcno files will already be there for sources,
    # but we still need to create the include/ subtree
    find . -type d -exec mkdir -p $GCOV_BASE/\{\} \;

    echo "Now linking the source files into place"
    find . -type f -name "*.c" -exec ln -s $PWD/\{\} $GCOV_BASE\{\} \;
    find . -type f -name "*.h" -exec ln -s $PWD/\{\} $GCOV_BASE\{\} \;
    find . -type f -name "*.debug" -exec ln -s $PWD/\{\} $GCOV_BASE\{\} \;
fi

cd -
lcov -d $GCOV_BASE -z

# Run all active regression tests
$sanitydir/BasicSanity.sh

lcov -d $GCOV_BASE -c -o pacemaker.info

rm -rf html
mkdir html
genhtml -o html pacemaker.info
